module Mmonews
  class Article
    attr_accessor :title, :summary, :content, :source,
                  :author, :url, :date_published

    @@all = []

    def initialize(article_attributes)
      article_attributes.each{ |key, value| send("#{key}=", value) }
    end

    def self.all
      @@all
    end

    def save
      self.class.all << self
    end

    def self.create(article_hash)
      self.new(article_hash).tap{ |s| s.save }
    end

    def self.find(id)
      self.all[id - 1]
    end

    def self.count
      self.all.length
    end

    def fetch_article
      data = Mmonews::Scraper.new(url).document
      self.content = data.search('div.commonContent').text.strip.gsub(/[\t\r\n]/, '')
      self
    end

    def self.print_articles
      self.all.each_with_index do |article, i|
        puts "#{i+1}. #{article.title}"
        puts "\t#{article.author} - #{article.date_published} - #{article.source}"
        puts "#{article.summary}\n"
      end
    end

    def print_full
      puts self.title
      puts "\t#{self.author} - #{self.date_published} - #{self.source}"
      puts self.content
    end

  end
end
