module Mmonews
  class CLI
    def call
      puts "----- Welcome to MMONEWSCLI -----"
      generate_articles
      display_articles

      input = 0
      until input && input.between?(1, Mmonews::Article.count)
        puts "\n\t Which article index # would you like to look at? (numbers only)"
        input = gets.strip.to_i
      end
      display_one_article(input)
    end

    def generate_articles
      scrapers = [Mmonews::MmorpgScraper]
      scrapers.each{ |s| s.new.create_articles }
    end

    def display_articles
      Mmonews::Article.print_articles
    end

    def display_one_article(index)
      article = Mmonews::Article.find(index).fetch_article
      article.print_full
    end

  end
end
