module Mmonews
  class MmorpgScraper
    attr_accessor :url, :page_scraper

    BASE_URL = 'https://mmorpg.com'
    SOURCE = 'mmorpg.com'

    def initialize
      self.url =  BASE_URL + '/articles'
      self.page_scraper = Mmonews::Scraper.new(url)
    end

    def page
      @page ||= page_scraper.document.search('.entry')
    end

    def create_articles
      page.collect do |p|
        article_url = BASE_URL + p.search('h1 a.title').attribute('href').value.strip
        author = p.search('p.body span.desc a').text

        article = {
          title: p.search('h1 a.title').text,
          date_published: p.search('p.body span.desc').text.gsub(" by #{author}", ""),
          author: author,
          source: SOURCE,
          url: article_url,
          summary: p.search('p.body').text
        }
        Mmonews::Article.create(article)
      end
    end

  end
end
