module Mmonews
  class Scraper
    attr_accessor :url, :elapsed_time

    @@all = []

    def initialize(url = "")
      self.url = url if self.class.valid_url?(url)
      self.save
    end

    def save
      self.class.all << self
    end

    def self.all
      @@all
    end

    def document
      start_time = Time.now
      begin
        @document ||= Nokogiri::HTML(open(self.url))
      rescue StandardError => error
        puts "Nokogiri invalid url:\n #{self.class} :: #{self}"
        puts "url: #{self.url}"
      end
      end_time = Time.now
      self.elapsed_time = (end_time - start_time)
      @document
    end

    def self.valid_url?(url)
      url =~ /\A#{URI::regexp}\z/ ? true : false
    end

  end
end
